<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: Database&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_database.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="class_database-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Database&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract collection of object.  
 <a href="class_database.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_database_8h_source.html">Database.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aaafc4cda318124e4d41c994ef9939fa0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaafc4cda318124e4d41c994ef9939fa0"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#aaafc4cda318124e4d41c994ef9939fa0">Database</a> ()</td></tr>
<tr class="memdesc:aaafc4cda318124e4d41c994ef9939fa0"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_database.html" title="Abstract collection of object. ">Database</a> new database from scratch. <br /></td></tr>
<tr class="separator:aaafc4cda318124e4d41c994ef9939fa0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f1458358b96c2e661d321f3bba963ff"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#a1f1458358b96c2e661d321f3bba963ff">Database</a> (<a class="el" href="class_database.html">Database</a> &amp;d)</td></tr>
<tr class="memdesc:a1f1458358b96c2e661d321f3bba963ff"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_database.html" title="Abstract collection of object. ">Database</a> deep copy of database.  <a href="#a1f1458358b96c2e661d321f3bba963ff">More...</a><br /></td></tr>
<tr class="separator:a1f1458358b96c2e661d321f3bba963ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4aa986777fd39f9c2cf20ccd0e981e7b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4aa986777fd39f9c2cf20ccd0e981e7b"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#a4aa986777fd39f9c2cf20ccd0e981e7b">~Database</a> ()</td></tr>
<tr class="memdesc:a4aa986777fd39f9c2cf20ccd0e981e7b"><td class="mdescLeft">&#160;</td><td class="mdescRight">~Database delete database <br /></td></tr>
<tr class="separator:a4aa986777fd39f9c2cf20ccd0e981e7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab71463e7202e9e13e6db713616d536c3"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#ab71463e7202e9e13e6db713616d536c3">operator[]</a> (int i) const </td></tr>
<tr class="memdesc:ab71463e7202e9e13e6db713616d536c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator [] reference to item  <a href="#ab71463e7202e9e13e6db713616d536c3">More...</a><br /></td></tr>
<tr class="separator:ab71463e7202e9e13e6db713616d536c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a904f8a7375009e5266c9ca3087506420"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#a904f8a7375009e5266c9ca3087506420">add</a> (T item, bool allowDuplicates=false)</td></tr>
<tr class="memdesc:a904f8a7375009e5266c9ca3087506420"><td class="mdescLeft">&#160;</td><td class="mdescRight">adds new item (if there is no duplicate)  <a href="#a904f8a7375009e5266c9ca3087506420">More...</a><br /></td></tr>
<tr class="separator:a904f8a7375009e5266c9ca3087506420"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6d8e1621305132ecca4e1b21e918d021"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#a6d8e1621305132ecca4e1b21e918d021">remove</a> (T item)</td></tr>
<tr class="memdesc:a6d8e1621305132ecca4e1b21e918d021"><td class="mdescLeft">&#160;</td><td class="mdescRight">removes from database all items equals to given one  <a href="#a6d8e1621305132ecca4e1b21e918d021">More...</a><br /></td></tr>
<tr class="separator:a6d8e1621305132ecca4e1b21e918d021"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e4e2967614f44e36de1e7fb80bb46de"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#a6e4e2967614f44e36de1e7fb80bb46de">replace</a> (T oldItem, T newItem)</td></tr>
<tr class="memdesc:a6e4e2967614f44e36de1e7fb80bb46de"><td class="mdescLeft">&#160;</td><td class="mdescRight">replaces item with new item if old item is in database  <a href="#a6e4e2967614f44e36de1e7fb80bb46de">More...</a><br /></td></tr>
<tr class="separator:a6e4e2967614f44e36de1e7fb80bb46de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e868f7b561ee7bec6dad42c632ca16d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#a9e868f7b561ee7bec6dad42c632ca16d">isInDatabase</a> (T item) const </td></tr>
<tr class="separator:a9e868f7b561ee7bec6dad42c632ca16d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2d166028b81d82ac3696b1055759792"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#ad2d166028b81d82ac3696b1055759792">search</a> (T item) const </td></tr>
<tr class="memdesc:ad2d166028b81d82ac3696b1055759792"><td class="mdescLeft">&#160;</td><td class="mdescRight">searches in database for given item  <a href="#ad2d166028b81d82ac3696b1055759792">More...</a><br /></td></tr>
<tr class="separator:ad2d166028b81d82ac3696b1055759792"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeefe0c4942913d067612694ce92b7c90"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">size</a> () const </td></tr>
<tr class="memdesc:aeefe0c4942913d067612694ce92b7c90"><td class="mdescLeft">&#160;</td><td class="mdescRight">gets size of database  <a href="#aeefe0c4942913d067612694ce92b7c90">More...</a><br /></td></tr>
<tr class="separator:aeefe0c4942913d067612694ce92b7c90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4a4b719e7cb7bdae488f56aab57c2c2"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#ab4a4b719e7cb7bdae488f56aab57c2c2">isEmpty</a> () const </td></tr>
<tr class="memdesc:ab4a4b719e7cb7bdae488f56aab57c2c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">checks if database is empty  <a href="#ab4a4b719e7cb7bdae488f56aab57c2c2">More...</a><br /></td></tr>
<tr class="separator:ab4a4b719e7cb7bdae488f56aab57c2c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb198e1ecf6f67b1e1cc3820dc05195f"><td class="memItemLeft" align="right" valign="top">std::vector&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">getItems</a> () const </td></tr>
<tr class="memdesc:acb198e1ecf6f67b1e1cc3820dc05195f"><td class="mdescLeft">&#160;</td><td class="mdescRight">getItems gets items in database  <a href="#acb198e1ecf6f67b1e1cc3820dc05195f">More...</a><br /></td></tr>
<tr class="separator:acb198e1ecf6f67b1e1cc3820dc05195f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:af4ddfaac7a165a20482cd5e78e437eaf"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_database.html#af4ddfaac7a165a20482cd5e78e437eaf">operator&lt;&lt;</a> (std::ostream &amp;out, const <a class="el" href="class_database.html">Database</a>&lt; T &gt; &amp;database)</td></tr>
<tr class="memdesc:af4ddfaac7a165a20482cd5e78e437eaf"><td class="mdescLeft">&#160;</td><td class="mdescRight">operator &lt;&lt; printer  <a href="#af4ddfaac7a165a20482cd5e78e437eaf">More...</a><br /></td></tr>
<tr class="separator:af4ddfaac7a165a20482cd5e78e437eaf"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;class T&gt;<br />
class Database&lt; T &gt;</h3>

<p>Abstract collection of object. </p>
<p>Copyright 2016-2017 Stefano Fogarollo</p>
<p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at </p><pre class="fragment">    http://www.apache.org/licenses/LICENSE-2.0
</pre><p>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a1f1458358b96c2e661d321f3bba963ff"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_database.html">Database</a>&lt; T &gt;::<a class="el" href="class_database.html">Database</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_database.html">Database</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>d</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p><a class="el" href="class_database.html" title="Abstract collection of object. ">Database</a> deep copy of database. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">d</td><td>database to copy </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a904f8a7375009e5266c9ca3087506420"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="class_database.html">Database</a>&lt; T &gt;::add </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>item</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>allowDuplicates</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>adds new item (if there is no duplicate) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">item</td><td>stuff to add </td></tr>
    <tr><td class="paramname">allowDuplicates</td><td>whether to allow duplicates in database or not </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acb198e1ecf6f67b1e1cc3820dc05195f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;T&gt; <a class="el" href="class_database.html">Database</a>&lt; T &gt;::getItems </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>getItems gets items in database </p>
<dl class="section return"><dt>Returns</dt><dd>items in database </dd></dl>

</div>
</div>
<a class="anchor" id="ab4a4b719e7cb7bdae488f56aab57c2c2"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="class_database.html">Database</a>&lt; T &gt;::isEmpty </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>checks if database is empty </p>
<dl class="section return"><dt>Returns</dt><dd>true if number of items is 0 </dd></dl>

</div>
</div>
<a class="anchor" id="a9e868f7b561ee7bec6dad42c632ca16d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="class_database.html">Database</a>&lt; T &gt;::isInDatabase </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if item is in database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">item</td><td>item to check </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true iff item is in database </dd></dl>

</div>
</div>
<a class="anchor" id="ab71463e7202e9e13e6db713616d536c3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="class_database.html">Database</a>&lt; T &gt;::operator[] </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>operator [] reference to item </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">i</td><td>iterator to get reference of </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>reference to item </dd></dl>

</div>
</div>
<a class="anchor" id="a6d8e1621305132ecca4e1b21e918d021"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="class_database.html">Database</a>&lt; T &gt;::remove </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>removes from database all items equals to given one </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">item</td><td>stuff to remove </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6e4e2967614f44e36de1e7fb80bb46de"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="class_database.html">Database</a>&lt; T &gt;::replace </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>oldItem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>newItem</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>replaces item with new item if old item is in database </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oldItem</td><td>old stuff to replace with new </td></tr>
    <tr><td class="paramname">newItem</td><td>new stuff </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad2d166028b81d82ac3696b1055759792"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="class_database.html">Database</a>&lt; T &gt;::search </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>searches in database for given item </p>
<dl class="section return"><dt>Returns</dt><dd>item (if found) or null </dd></dl>

</div>
</div>
<a class="anchor" id="aeefe0c4942913d067612694ce92b7c90"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="class_database.html">Database</a>&lt; T &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>gets size of database </p>
<dl class="section return"><dt>Returns</dt><dd>number of items in database </dd></dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a class="anchor" id="af4ddfaac7a165a20482cd5e78e437eaf"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="class_database.html">Database</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>database</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>operator &lt;&lt; printer </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">out</td><td>stream </td></tr>
    <tr><td class="paramname">object</td><td>to print </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>print object </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>models/Database/<a class="el" href="_database_8h_source.html">Database.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_database.html">Database</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
